<?php
/**
 * OnePica
 * NOTICE OF LICENSE
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to codemaster@onepica.com so we can send you a copy immediately.
 *
 * @category    Affirm
 * @package     Affirm_Affirm
 * @copyright   Copyright (c) 2014 One Pica, Inc. (http://www.onepica.com)
 * @license     http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

/**
 * Class Affirm_Affirm_Helper_Payment_Data
 */
class Affirm_Affirm_Helper_Payment_Data extends Mage_Payment_Helper_Data
{
    protected $_allRules = null;
    
    public function getStoreMethods($store = null, $quote = null)
    {
        $methods = parent::getStoreMethods($store, $quote);
        if (!$quote){
            return $methods;
        }
        $address = $quote->getShippingAddress();
        foreach ($methods as $k => $method){
            foreach ($this->getRules($address) as $rule){
               if ($rule->restrict($method)){
                   if ($rule->validate($address)){
                       unset($methods[$k]);
                   }//if validate
               }//if restrict
            }//rules        
        }//methods
        return $methods;
    }
    
    public function getRules($address)
    {
        if (is_null($this->_allRules)){
            $this->_allRules = Mage::getModel('affirm/rule')
                ->getCollection()
                ->addAddressFilter($address)
             ;
             if ($this->_isAdmin()){
                 $this->_allRules->addFieldToFilter('for_admin', 1);
             }
             
            $this->_allRules->load();
            foreach ($this->_allRules as $rule){
                $rule->afterLoad(); 
            }
        }
        
        return  $this->_allRules;       
    }
    
    protected function _isAdmin()
    {
        if (Mage::app()->getStore()->isAdmin())
            return true;
        if (Mage::app()->getRequest()->getControllerName() == 'sales_order_create')
            return true;
            
        return false;
    }    
    
}